export mean, variance, mean_var, rand, loglikelihood

abstract type AbstractPDF end
abstract type AbstractCPDF end

"""
    mean_var(p::AbstractPDF)

Returns mean and variance of a PDF.
"""
mean_var(p::AbstractPDF) = error("Not implemented!")

"""
    mean(p::AbstractPDF)

Returns mean of a PDF.
"""
mean(p::AbstractPDF) = mean_var(p::AbstractPDF)[1]

"""
    variance(p::AbstractPDF)

Returns variance of a PDF.
"""
variance(p::AbstractPDF) = mean_var(p::AbstractPDF)[2]

"""
    rand(p::AbstractPDF; batch=1)

Produce `batch` number of samples from a PDF.
"""
rand(p::AbstractPDF, batchsize::Int=1) = error("Not implemented!")

"""
    loglikelihood(p::AbstractPDF, x::AbstractArray)

Computes log p(x|μ,σ2).
"""
loglikelihood(p::AbstractPDF, x::AbstractArray) = error("Not implemented!")


"""
    mean_var(p::AbstractCPDF, z::AbstractArray)

Returns mean and variance of a conditional PDF.
"""
mean_var(p::AbstractCPDF, z::AbstractArray) = error("Not implemented!")


"""
    mean(p::AbstractCPDF, z::AbstractArray)

Returns mean of a conditional PDF.
"""
mean(p::AbstractCPDF, z::AbstractArray) = mean_var(p, z)[1]

"""
    variance(p::AbstractCPDF, z::AbstractArray)

Returns variance of a conditional PDF.
"""
variance(p::AbstractCPDF, z::AbstractArray) = mean_var(p, z)[2]

"""
    rand(p::AbstractCPDF, z::AbstractArray)

Produce `batch` number of samples from a conditional PDF.
"""
rand(p::AbstractCPDF, z::AbstractArray) = error("Not implemented!")

"""
    loglikelihood(p::AbstractCPDF, x::AbstractArray, z::AbstractArray)

Computes log p(x|z).
"""
loglikelihood(p::AbstractCPDF, x::AbstractArray, z::AbstractArray) = error("Not implemented!")
